(* fonction de remplacement d'individus ds une population *)

let remplace population ind_a_remplacer ind_qui_remplace =
   let trajet_de_remplacement = (population.(ind_qui_remplace)).trajet 
     and fitness_de_remplacement = (population.(ind_qui_remplace)).fitness in
   population.(ind_a_remplacer) <-  {trajet = trajet_de_remplacement ; 
                                                 fitness = fitness_de_remplacement ; 
                                                 cfitness = 0. ; rfitness = 0. } ;;

(* fonction plaant le meilleur individu  la place du dernier de la population *)

let garde_le_meilleur population =
   let nb_ind = vect_length population in
   let le_meilleur = ref 0 and best_fitness = ref 0. in
   for i = 0 to (nb_ind - 1)
   do
     if (population.(i)).fitness >=. !best_fitness 
     then
       begin 
         le_meilleur := i ;
         best_fitness := (population.(i)).fitness ;
       end;
   done;
   imprime [|String "meilleur individu :";Int !le_meilleur |] false ;
   imprime [|String " -> on remplace le dernier par celui-l" |] false ;
   remplace population (nb_ind - 1) !le_meilleur ;
   imprime [|String "maintenant le dernier est :" ;
                 Int_vect population.(nb_ind - 1).trajet  |] false ;
   imprime [|String "et sa fitness : ";Float population.(nb_ind - 1).fitness |] false ;;

(* fonction conservant le meilleur individu dans la population *)

let elitiste population = 
   let nb_ind = vect_length population in 
   let le_meilleur = ref 0 and le_pire = ref 0 in
   for i = 0 to nb_ind - 2
   do
     if population.(i).fitness >. population.(!le_meilleur).fitness
     then le_meilleur := i ;
     if population.(i).fitness <. population.(!le_pire).fitness
     then le_pire := i ;
   done ;
   if population.(!le_meilleur).fitness <. population.(nb_ind - 1).fitness
   then remplace population (!le_pire) (nb_ind - 1) 
   else remplace population (nb_ind - 1) (!le_meilleur) ;;    

